import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';

class FlutterBidmadCommon {
  static const _DEFAULT_CHANNELNAME = "com.bidmad.sdk.common/Flutter";
  MethodChannel _platform;

  FlutterBidmadCommon(){
    _initChannel(_DEFAULT_CHANNELNAME);
  }

  Future<void> _initChannel(String channelNm) async {
    _platform = MethodChannel(channelNm);
    _platform.setMethodCallHandler(_handleMethod);
  }

  Future<void> setDebugging(bool isDebug) async {
    await _platform.invokeMethod('setDebugging', {"isDebug":isDebug});
  }

  Future<void> initBannerChannel() async {
    await _platform.invokeMethod('initBannerChannel');
  }

  Future<void> initInterstitialChannel() async {
    await _platform.invokeMethod('initInterstitialChannel');
  }

  Future<String> initRewardChannel() async {
    String chanNm = await _platform.invokeMethod('initRewardChannel');
    print("initRewardChannel = " + chanNm);
    return chanNm;
  }

  Future<dynamic> _handleMethod(MethodCall call) async {
    switch (call.method) {
      default:
        throw ('method not defined');
    }
  }
}